<template>
  <div class="row q-col-gutter-sm">
    <div class="col-lg-2 col-xs-12">
      <q-card>
        <q-card-section>
          <div class="q-gutter-md q-pb-sm">
            <q-input
              v-model="edicionMasiva.libro"
              @update:model-value="changeEstados()"
              filled
              dense
              label="Libro"
            >
              <template v-slot:prepend>
                <q-icon name="auto_stories" />
              </template>
            </q-input>
            <q-input
              v-model="edicionMasiva.folio"
              @update:model-value="changeEstados()"
              filled
              dense
              label="Folio"
            >
              <template v-slot:prepend>
                <q-icon name="library_books" />
              </template>
            </q-input>
            <q-select
              v-model="edicionMasiva.estado"
              @update:model-value="changeEstados()"
              style="min-width: 150px"
              dense
              filled
              emit-value
              stack-label
              map-options
              :options="[
                { label: 'En Curso', value: 1 },
                { label: 'Acreditado', value: 2 },
                { label: 'No Acredita', value: 5 },
                { label: 'Pendiente Trabajo', value: 3 },
                { label: 'Ausente', value: 6 },
              ]"
              label="Estado: "
            />
          </div>
          <q-btn
            class="full-width"
            size="sm"
            color="green"
            :disable="loading"
            @click="actualizarDatos"
          >
            Guardar Cambios
          </q-btn>
        </q-card-section>
        <Loading :showing="loading" />
      </q-card>
    </div>
    <div class="col-lg-10 col-xs-12">
      <q-markup-table>
        <thead>
          <tr>
            <th>Datos</th>
            <th></th>
            <th>Libro</th>
            <th>Folio</th>
            <th v-if="experiencia?.solicita_rama">Rama</th>
            <th>Estado</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="participante in dataSet" :key="participante.uuid">
            <td>
              <PersonaDetalle :persona="participante.persona" />
            </td>
            <td>
              <EstadoExperiencia :estado="participante.estado_id" />
            </td>

            <td>
              <q-input filled dense v-model="participante.libro" />
            </td>
            <td>
              <q-input filled dense v-model="participante.folio" />
            </td>
            <td v-if="experiencia.solicita_rama">
              <SelectRama v-model="participante.rama" label="" />
            </td>
            <td>
              <q-select
                v-model="participante.estado_id"
                style="min-width: 150px"
                dense
                filled
                emit-value
                stack-label
                map-options
                :options="[
                  { label: 'En Curso', value: 1 },
                  { label: 'Acreditado', value: 2 },
                  { label: 'No Acredita', value: 5 },
                  { label: 'Pendiente Trabajo', value: 3 },
                  { label: 'Ausente', value: 6 },
                ]"
                label="Estado: "
              />
            </td>
          </tr>
        </tbody>
        <Loading :showing="loading" />
      </q-markup-table>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref, reactive, PropType } from 'vue';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import { useRoute, useRouter } from 'vue-router';
import {
  ExperienciaInterface,
  FormacionParticipantesInterface,
} from 'src/interfaces/FormacionInterface';
import PersonaDetalle from 'components/Personas/Detalle.vue';
import SelectRama from 'src/components/Form/selectRama.vue';
import EstadoExperiencia from 'src/components/Formacion/EstadoExperiencia.vue';
import Loading from 'src/components/Loading.vue';

export default defineComponent({
  name: 'ListadoParticipantesPartial',
  props: {
    experiencia: {
      type: Object as PropType<ExperienciaInterface>,
      required: true,
    },
  },

  components: { Loading, PersonaDetalle, SelectRama, EstadoExperiencia },

  setup(props) {
    const loading = ref(true);
    const route = useRoute();
    const router = useRouter();
    const uuid = String(route.params.uuid);

    const edicionMasiva = reactive({
      libro: 0,
      folio: 0,
      estado: '',
    });

    onMounted(async () => {
      onRequest();

      // debido a que experiencia no tiene datos al inicializar, quedo en loop hasta que carga los datos.
      while (props.experiencia == undefined) {
        await wait(100);
      }
    });

    function wait(time: number): Promise<void> {
      return new Promise((resolve) => {
        setTimeout(() => {
          resolve();
        }, time);
      });
    }

    const dataSet = ref<FormacionParticipantesInterface[]>();
    function onRequest() {
      loading.value = true;
      api
        .get('/api/formacion/participantes', {
          params: {
            rowsPerPage: 99999,
            curso_uuid: uuid,
          },
        })
        .then((response: AxiosResponse) => {
          dataSet.value = response.data.data;
          loading.value = false;
        })
        .finally(() => {
          loading.value = false;
        });
    }

    function changeEstados() {
      dataSet.value?.forEach(function (item) {
        item.estado_id = edicionMasiva.estado;
        item.libro = edicionMasiva.libro;
        item.folio = edicionMasiva.folio;
      });
    }

    function actualizarDatos() {
      loading.value = true;

      let data = [];
      dataSet.value?.forEach(function (item) {
        data.push({
          uuid: item.uuid,
          estado: item.estado_id,
          rama: item.rama,
          libro: item.libro,
          folio: item.folio,
        });
      });

      api
        .put('/api/formacion/participantes/masivo', {
          curso_uuid: uuid,
          data,
        })
        .then(() => {
          router.push({ path: '/formacion/experiencias/detalle/' + uuid });
        })
        .finally(() => {
          loading.value = false;
        });
    }

    return {
      edicionMasiva,
      dataSet,
      onRequest,
      loading,
      changeEstados,
      actualizarDatos,
    };
  },
});
</script>
